.\" Copyright (c) 1980, 1990, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by the University of
.\"	California, Berkeley and its contributors.
.\" 4. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)strings.1	8.1 (Berkeley) 6/6/93
.\"
.Dd June 6, 1993
.Dt STRINGS 1
.Os BSD 3
.Sh NAME
.Nm strings
.Nd find printable strings in a file
.Sh SYNOPSIS
.Nm
.Op Fl afo
.Op Fl n Ar number
.Op Ar
.Sh DESCRIPTION
.Nm Strings
displays the sequences of printable characters in each of the specified
files, or in the standard input, by default.
By default, a sequence must be at least four characters in length
before being displayed.
.Pp
The options are as follows:
.Bl -tag -width Ds
.It Fl a
By default,
.Nm
only searches the text and data segments of object files.
The
.Fl a
option causes
.Nm
to search the entire object file.
.It Fl f
Each string is preceded by the name of the file
in which it was found.
.It Fl n
Specifies the minimum number of characters in a sequence to be
.Ar number ,
instead of four.
.It Fl o
Each string is preceded by its decimal offset in the
file.
.El
.Pp
.Nm Strings
is useful for identifying random binaries, among other things.
.Sh SEE ALSO
.Xr hexdump 1
.Sh BUGS
The algorithm for identifying strings is extremely primitive.
In particular, machine code instructions on certain architectures
can resemble sequences of ASCII bytes, which
will fool the algorithm.
.Sh COMPATIBILITY
Historic implementations of
.Nm
only search the initialized data portion of the object file.
This was reasonable as strings were normally stored there.
Given new compiler technology which installs strings in the 
text portion of the object file, the default behavior was
changed.
.Sh HISTORY
The
.Nm
command appeared in
.Bx 3.0 .
